您的位置:首页 > 其它

[DP] HDU 1024 Max Sum Plus Plus

2018-04-09 11:53 441 查看

Max Sum Plus Plus

[align=left]Problem Description[/align]Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

Given a consecutive number sequence S1, S2, S3, S4 ... Sx, ... Sn (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ Sx ≤ 32767). We define a function sum(i, j) = Si + ... + Sj (1 ≤ i ≤ j ≤ n).

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i1, j1) + sum(i2, j2) + sum(i3, j3) + ... + sum(im, jm) maximal (ix ≤ iy ≤ jx or ix ≤ jy ≤ jx is not allowed).

But I`m lazy, I don't want to write a special-judge module, so you don't have to output m pairs of i and j, just output the maximal summation of sum(ix, jx)(1 ≤ x ≤ m) instead. ^_^
 
[align=left]Input[/align]Each test case will begin with two integers m and n, followed by n integers S1, S2, S3 ... Sn.
Process to the end of file.
 
[align=left]Output[/align]Output the maximal summation described above in one line.
 
[align=left]Sample Input[/align]
1 3 1 2 32 6 -1 4 -2 3 -2 3 
[align=left]Sample Output[/align]
68

aa0c

【题目大意】发现网上没有个正经的翻译,我一开始就是题意理解错误,一直不能AC。题目的意思是这样的:给你一段由n个数组成的数组,请你从中抽取m段数,使这m段数之和最大。(求n个元素数组的m段连续子段和的最大值)
【题解】dp[i][j]=前j个数选择i段的最大值状态转移:dp[i][j]=max(dp[i][j-1]  ,  max{dp[i-1][k]}  )+a[j]  (i-1<=k<=j-1)第J个元素可以和前面的连接在一起,构成i段,或者独自成为一段,如果是独自成为一段的话,那么前j-1个数必须组合出i-1段,选择多种情况里的最大值,
【状态压缩】由于数据较大,但是我们发现,每一次状态转移至用到了d[i][]和d[i-1][],所以我们直接去掉i这一维,用pre[]保留d[i-1]
//看懂了记得点赞啊#include<cstdio>
#include<algorithm>
#include<cmath>
#include<cstdlib>
#include<cstring>
#define INF 2147483640
using namespace std;
const int maxn=1000005;
typedef __int64 LL;

int a[maxn],dp[maxn];
int pre[maxn];//对应递推式的第二项
int main(){
int T;
int n,m;
while(~scanf("%d%d",&m,&n)){
for(int i=1;i<=n;i++){
scanf("%d",a+i);
dp[i]=pre[i]=0;
}
int mx;
dp[0]=pre[0]=0;
for(int i=1;i<=m;i++){
mx=-INF;
for(int j=i;j<=n;j++){
dp[j]=max(dp[j-1],pre[j-1])+a[j]; //dp[i][j]=max{dp[i][j-1],dp[i-1][k]}+a[j];
pre[j-1]=mx;
mx=max(dp[j],mx);
}
}
printf("%d\n",mx);
}
return 0;
} https://blog.csdn.net/u013167299/article/details/44703807我是参考了这位大佬的程序
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  动态规划